#! /bin/sh
# Copyright blue_led@maemo.org

m1="Peripheral mode"
m2="Switch usb to Host-mode"
m3="Apply power to device"
m4="BME still alive ! Abort."
m5="Searching for "
m6="Turn off Vbus"
m7="Start battery managenent"
m8="No device found"
m9="Unable to set Host-mode"
m10="Find removable device. Mounting..."
m11="High power charger connected ! Abort."
m12="Computer or external power connected ! Abort."
m13="...found something"
m14="sd.*Attached SCSI removable disk"
m15="sr.*Attached.*CD.*"

em0="Forced hostmode error: no device attached"
em1="Forced hostmode error: a full/high-speed device attached but low-speed mode selecte"
em2="Forced hostmode error: a low-speed device attached but full/high-speed mode selected"
em3="Forced hostmode error: a full/low-speed device attached but high-speed mode selected"
em4="Forced hostmode error: a high-speed device attached but not high-speed mode selected"
em5="usb.*bus auto-suspend"
em6="usb.*Product.*"
emv1="twl4030_usb twl4030_usb: HW_CONDITIONS.*link 1"
emv2="twl4030_usb twl4030_usb: HW_CONDITIONS.*link 2"
emk="usb.*khubd timed out.*"
emh="usb.*uevent"
emh1="hub.*enable change, status.*"
emh2="hub.*unable to enumerate USB device"
emh3="hub.*unable to enumerate USB device on port 1"
emu="usb.*unregistering interface"
emr="musb_hdrc musb_hdrc: USB bus 1 deregistered"

o=org
f=freedesktop
n=Notifications
sysfs_usb=/sys/devices/platform/musb_hdrc
driver=/proc/driver/musb_hdrc
sa_icon=/usr/share/applications/hildon-status-menu/hostmode.desktop
h_icon=/opt/host/host_mode_icon.desktop

verbose=false

banner(){
dbus-send --system --type=method_call \
--dest=$o.$f.$n /$o/$f/$n $o.$f.$n.SystemNoteInfoprint string:"$1"
}
charger(){
echo $(cat $sysfs_usb/charger)
}
vbus(){
echo $(cat /sys/class/i2c-adapter/i2c-1/1-0048/twl4030_usb/vbus)
}
boost(){
if [ $1 = 0 ]
then
#[ $verbose ] && banner "$m6"
killall booston;sleep 1;i2cset -y -m 0x01 2 0x6b 0x01 0x00
else
[ $verbose ] && banner "$m3"
(/home/opt/host/booston &)
fi
}
when(){
x=$(echo $(dmesg|grep "$1"|tail -1))
x=$(echo ${x%%"] "*}|tr " "[. 0)
[ -z $x ] && echo 0 ||echo $x
}
waitmess(){
local message=$1
[ $2 = 2 ] && time_vbus="$(when "$emv2")" || time_vbus="$(when "$emv1")"
until [ $time_vbus -lt $(when "$message") ]
do sleep 1; done
}
waitbus(){
echo peripheral > $sysfs_usb/mode
boost 0
#waitmess "$emv1" 2
waitmess "$em5" 1
}
peripheral(){
killall ossofilemanager
/opt/h-e-n/mount.sh --unmount
[ -f $sysfs_usb/usb1/1-1/authorized ] && echo 0 > $sysfs_usb/usb1/1-1/authorized
rm -f $sa_icon
modprobe g_file_storage
waitmess "$em5" 1
echo peripheral > $sysfs_usb/mode
banner "$m1";sleep 1
[ "$(pidof booston)" ] && boost 0
[ ! "$(pidof  bme_RX-51)" ] && ( banner "$m7";sleep 5;start -q bme )
}
setmode(){
echo host$1 > $sysfs_usb/mode
sleep 1
boost 1
while [ "$(vbus)" = 0 ];do sleep 1;done
time_vbus="$(when "$emv2")"
}
switchspeed(){
banner "$m5""high speed"
rmmod g_file_storage
waitmess "$emr" 0
boost 0
waitmess "$emv1" 2
modprobe g_file_storage
waitmess "$em5" 1
try h
}
geterr(){
te0=$(when "$em0")
te1=$(when "$em1")
te2=$(when "$em2")
te3=$(when "$em3")
te4=$(when "$em4")
tm=09999999999999
k=0;j=ne
for i in $te0 $te1 $te2 $te3 $te4
#for i in 0 1 2 3 4
do
if [ $i -ge $time_vbus -a $i -lt $tm ]
then
tm=$i;j=$k
fi
k=$(($k+1))
done
case $j in
4)s=h;;1|3)s=f;;2)s=l;;0)s=0;;*)s=ne
[ $time_vbus -lt $(when "$em6") ] && s=p;;
esac
[ $time_vbus -lt $(when "$emk") ] && s=k
}
try(){
setmode $1
echo F > $driver
sleep 1
geterr
}
probe2(){
banner "$m5""full speed device"
boost 0
waitmess "$emv1" 2
modprobe g_file_storage
waitmess "$em5" 1
sp=$1
step=1
e=false
until [ $step -gt 2 -o $e = true ]
do
try $sp
case $s in
$1|l|0|p)e=true;;
h)sp=h;banner "$m5""high speed";switchspeed;e=true;;
k)waitbus;;
esac
step=$(($step+1))
done
}
probe1(){
banner "$m5""low speed device"
rmmod g_file_storage
waitmess "$emr" 0
try l
case $s in
#0)echo "no device";;
f)probe2 f;;
ne)probe2 l;;
esac
}
host(){
banner "$m2"
stop -q bme
sleep 1
if [ "$(pidof  bme_RX-51)" ]
then
banner "$m4"
else
probe1
case $s in
l|f|h|k)(banner "$m9";sleep 1)
peripheral;;
0)(banner "$m8";sleep 1)
peripheral;;
p)cp $h_icon $sa_icon
(banner "$m13";sleep 1)
sleep 7
time_sd=$(when "$m14")
if [ $time_vbus -lt $time_sd ]
then
banner "$m10"
(/opt/host/mount.sh --mount -o -MF)
fi;;
esac
fi
}
mode="$(cat /proc/driver/musb_hdrc | grep "Mode=")"
mode=${mode##*"Mode="}
mode=${mode%%" "*}
#echo $mode
if [ $mode = "Peripheral" ]
then
if [ "$(charger)" = 1 ] 
then banner "$m11"
elif [ "$(vbus)" = 1 ]
then banner "$m12"
else host
fi
else
peripheral
fi
