#!/bin/sh

# Part of h-e-n, this is not The Right Way(TM) to handle file system mounting.
# ke-recv always runs on Maemo 5 as a daemon, yet it does not properly handle
# mounting.
# Help would be appreciated with ke-recv.

# Thanks to debernardis for help with the script.

prefix=run-standalone.sh
launch="dbus-send --type=method_call --dest=com.nokia.HildonDesktop.AppMgr /com/nokia/HildonDesktop/AppMgr com.nokia.HildonDesktop.AppMgr.LaunchApplication string:"
loadmodules() {
[ -f /lib/modules/"`uname -r`"/ntfs.ko ] && modprobe ntfs
[ -f /lib/modules/"`uname -r`"/isofs.ko ] && modprobe isofs
} 

mountpartitions() {
list=`awk '$4~"[0-9]$"{print $4}' /proc/partitions | grep -v "mmcblk*" | grep -v "loop*"`
for partitions in $list
 do
 mkdir -p /media/$partitions
 loadmodules
 mount -o uid=29999,gid=29999,utf8,dmask=027,fmask=137 /dev/$partitions /media/$partitions
  if [ "$?" = "0" ]
  then 
  success=$partitions
  $prefix dbus-send --type=method_call --dest=org.freedesktop.Notifications /org/freedesktop/Notifications org.freedesktop.Notifications.SystemNoteInfoprint string:"Successfully mounted /dev/$success on /media/$success!"
  mounted=yes
  fi
 done
}

unmount() {
lista=`awk '$4~"[0-9]$"{print $4}' /proc/partitions | grep -v "mmcblk*" | grep -v "loop*"`
for partitions in $lista
 do
 umount /media/$partitions
 rmdir /media/$partitions
 done
}   

case $1 in
"--mount")mountpartitions;;
"--unmount")unmount;;
esac

if [ "$2" = "--openfilemanager" -o "$2" = "-o" ]
then
if [ "$mounted" = "yes" ]
then
case $3 in
"--filebox"|"-F")$prefix $launch"filebox";;
"--osso-filemanager"|"-MF")$prefix $launch"filemanager";;
esac
fi
fi
